using CallCenterApi.DB;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CallCenterApi.DAL
{
    /// <summary>
    /// 数据访问类:T_Sys_IVRWords
    /// </summary>
    public partial class T_Sys_IVRWords
    {
        public T_Sys_IVRWords()
        { }
        #region  BasicMethod


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(CallCenterApi.Model.T_Sys_IVRWords model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Sys_IVRWords(");
            strSql.Append("F_Title,F_Content,F_Type,F_WavOldName,F_WavNewName,F_WavPath,F_StartDate,F_EndDate,F_Remark,F_IsState,F_CreateTime,F_CreateUser,F_IsDel)");
            strSql.Append(" values (");
            strSql.Append("@F_Title,@F_Content,@F_Type,@F_WavOldName,@F_WavNewName,@F_WavPath,@F_StartDate,@F_EndDate,@F_Remark,@F_IsState,@F_CreateTime,@F_CreateUser,@F_IsDel)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Title", SqlDbType.NVarChar,500),
                    new SqlParameter("@F_Content", SqlDbType.NText),
                    new SqlParameter("@F_Type", SqlDbType.Int,4),
                    new SqlParameter("@F_WavOldName", SqlDbType.NVarChar,500),
                    new SqlParameter("@F_WavNewName", SqlDbType.NVarChar,500),
                    new SqlParameter("@F_WavPath", SqlDbType.NText),
                    new SqlParameter("@F_StartDate", SqlDbType.DateTime),
                    new SqlParameter("@F_EndDate", SqlDbType.DateTime),
                    new SqlParameter("@F_Remark", SqlDbType.NText),
                    new SqlParameter("@F_IsState", SqlDbType.Int,4),
                    new SqlParameter("@F_CreateTime", SqlDbType.DateTime),
                    new SqlParameter("@F_CreateUser", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_IsDel", SqlDbType.Int,4)};
            parameters[0].Value = model.F_Title;
            parameters[1].Value = model.F_Content;
            parameters[2].Value = model.F_Type;
            parameters[3].Value = model.F_WavOldName;
            parameters[4].Value = model.F_WavNewName;
            parameters[5].Value = model.F_WavPath;
            parameters[6].Value = model.F_StartDate;
            parameters[7].Value = model.F_EndDate;
            parameters[8].Value = model.F_Remark;
            parameters[9].Value = model.F_IsState;
            parameters[10].Value = model.F_CreateTime;
            parameters[11].Value = model.F_CreateUser;
            parameters[12].Value = model.F_IsDel;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(CallCenterApi.Model.T_Sys_IVRWords model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Sys_IVRWords set ");
            strSql.Append("F_Title=@F_Title,");
            strSql.Append("F_Content=@F_Content,");
            strSql.Append("F_Type=@F_Type,");
            strSql.Append("F_WavOldName=@F_WavOldName,");
            strSql.Append("F_WavNewName=@F_WavNewName,");
            strSql.Append("F_WavPath=@F_WavPath,");
            strSql.Append("F_StartDate=@F_StartDate,");
            strSql.Append("F_EndDate=@F_EndDate,");
            strSql.Append("F_Remark=@F_Remark,");
            strSql.Append("F_IsState=@F_IsState,");
            strSql.Append("F_CreateTime=@F_CreateTime,");
            strSql.Append("F_CreateUser=@F_CreateUser,");
            strSql.Append("F_IsDel=@F_IsDel");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Title", SqlDbType.NVarChar,500),
                    new SqlParameter("@F_Content", SqlDbType.NText),
                    new SqlParameter("@F_Type", SqlDbType.Int,4),
                    new SqlParameter("@F_WavOldName", SqlDbType.NVarChar,500),
                    new SqlParameter("@F_WavNewName", SqlDbType.NVarChar,500),
                    new SqlParameter("@F_WavPath", SqlDbType.NText),
                    new SqlParameter("@F_StartDate", SqlDbType.DateTime),
                    new SqlParameter("@F_EndDate", SqlDbType.DateTime),
                    new SqlParameter("@F_Remark", SqlDbType.NText),
                    new SqlParameter("@F_IsState", SqlDbType.Int,4),
                    new SqlParameter("@F_CreateTime", SqlDbType.DateTime),
                    new SqlParameter("@F_CreateUser", SqlDbType.NVarChar,50),
                    new SqlParameter("@F_IsDel", SqlDbType.Int,4),
                    new SqlParameter("@F_ID", SqlDbType.Int,4)};
            parameters[0].Value = model.F_Title;
            parameters[1].Value = model.F_Content;
            parameters[2].Value = model.F_Type;
            parameters[3].Value = model.F_WavOldName;
            parameters[4].Value = model.F_WavNewName;
            parameters[5].Value = model.F_WavPath;
            parameters[6].Value = model.F_StartDate;
            parameters[7].Value = model.F_EndDate;
            parameters[8].Value = model.F_Remark;
            parameters[9].Value = model.F_IsState;
            parameters[10].Value = model.F_CreateTime;
            parameters[11].Value = model.F_CreateUser;
            parameters[12].Value = model.F_IsDel;
            parameters[13].Value = model.F_ID;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_ID)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Sys_IVRWords ");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ID;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_IDlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Sys_IVRWords ");
            strSql.Append(" where F_ID in (" + F_IDlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Sys_IVRWords GetModel(int F_ID)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 * from T_Sys_IVRWords ");
            strSql.Append(" where F_ID=@F_ID");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_ID", SqlDbType.Int,4)
            };
            parameters[0].Value = F_ID;

            CallCenterApi.Model.T_Sys_IVRWords model = new CallCenterApi.Model.T_Sys_IVRWords();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public CallCenterApi.Model.T_Sys_IVRWords DataRowToModel(DataRow row)
        {
            CallCenterApi.Model.T_Sys_IVRWords model = new CallCenterApi.Model.T_Sys_IVRWords();
            if (row != null)
            {
                if (row["F_ID"] != null && row["F_ID"].ToString() != "")
                {
                    model.F_ID = int.Parse(row["F_ID"].ToString());
                }
                if (row["F_Title"] != null)
                {
                    model.F_Title = row["F_Title"].ToString();
                }
                if (row["F_Content"] != null)
                {
                    model.F_Content = row["F_Content"].ToString();
                }
                if (row["F_Type"] != null && row["F_Type"].ToString() != "")
                {
                    model.F_Type = int.Parse(row["F_Type"].ToString());
                }
                if (row["F_WavOldName"] != null)
                {
                    model.F_WavOldName = row["F_WavOldName"].ToString();
                }
                if (row["F_WavNewName"] != null)
                {
                    model.F_WavNewName = row["F_WavNewName"].ToString();
                }
                if (row["F_WavPath"] != null)
                {
                    model.F_WavPath = row["F_WavPath"].ToString();
                }
                if (row["F_StartDate"] != null && row["F_StartDate"].ToString() != "")
                {
                    model.F_StartDate = DateTime.Parse(row["F_StartDate"].ToString());
                }
                if (row["F_EndDate"] != null && row["F_EndDate"].ToString() != "")
                {
                    model.F_EndDate = DateTime.Parse(row["F_EndDate"].ToString());
                }
                if (row["F_Remark"] != null)
                {
                    model.F_Remark = row["F_Remark"].ToString();
                }
                if (row["F_IsState"] != null && row["F_IsState"].ToString() != "")
                {
                    model.F_IsState = int.Parse(row["F_IsState"].ToString());
                }
                if (row["F_CreateTime"] != null && row["F_CreateTime"].ToString() != "")
                {
                    model.F_CreateTime = DateTime.Parse(row["F_CreateTime"].ToString());
                }
                if (row["F_CreateUser"] != null)
                {
                    model.F_CreateUser = row["F_CreateUser"].ToString();
                }
                if (row["F_IsDel"] != null && row["F_IsDel"].ToString() != "")
                {
                    model.F_IsDel = int.Parse(row["F_IsDel"].ToString());
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select * ");
            strSql.Append(" FROM T_Sys_IVRWords ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" * ");
            strSql.Append(" FROM T_Sys_IVRWords ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Sys_IVRWords ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_ID desc");
            }
            strSql.Append(")AS Row, T.*  from T_Sys_IVRWords T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}
